#!/bin/bash

rhere=$( realpath "$BASH_SOURCE" )
[[ $rhere ]] && rheredir=${rhere%/*} ||
here=${BASH_SOURCE##/*} here=${here:+$PWD/$here} here=${here:-$BASH_SOURCE} heredir=${here%/*} \
rhere=$here rheredir=$heredir \
supported='@(eval[12]|set|shopt|declare|alias|function|override)'
#exclude='!(.@(off|xbloff?(.*)|sw[a-z])'

shopt -s nullglob dotglob globstar extglob expand_aliases

set -- "$rheredir" "$@"

[[ -v xblpe ]] && eval -- "$xblpe"

${xblp+${ye=}cat} ${ye-.} <(
for project ; do
 [[ ! -d $project ]] && continue
 project=$( realpath "$project" )
  if [[ -v xblf ]] ; then
   tr \\0 \\n
  else
   [[ -d "$project"/bin ]] && xblm="mkPATH '${project//\'/\'\\\'\'}'"/bin || xblm=
   gawk ${xgp+-W profile} -v xblm="$xblm" -f "$rheredir"/bin/xbl.gawk
  fi < <(
   files=( ) ; declare -A dirs=( )
   for dir in "$project"/$supported/**/ ; do
    dirs[${dir%/}]=
   done
   for all in "$project"/$supported/**/* ; do
    [[ ! -v dirs[${all%/}] ]] && files+=( "$all" )
   done
   printf %s\\0 "$project" "${files[@]}"
 )
done
)

[[ -v xble ]] &&
 eval -- "$xble"